#define TIMCLK 1000000 //1MHZ
#define TIMCLKENX 1
#define TIMER0_PRESCALE 1


// Scheduler
#define TIMER0_HZ 5000          // the frequency of timer0 IRQ
#define TASK_QUANTUM 1          // 1ms per task
#define TIMER0_RELOAD_VALUE     ((TIMCLK/TIMER0_HZ)/(TIMCLKENX*TIMER0_PRESCALE))
//#define TIMER0_RELOAD_VALUE     (((1000/TIMER0_HZ)*TIMCLK)/(TIMCLKENX*TIMER0_PRESCALE))
#define TASK_QUANTUM_COUNTER    ((TIMER0_HZ*TASK_QUANTUM)/1000)

#define SDRAM_START 0x70000000
#define SDRAM_END   0x90000000

#define STACK_BASE_FIQ   (SDRAM_START+0x1000)
#define STACK_BASE_ABORT   (SDRAM_START+0x3000)
#define STACK_BASE_UNDEFINED   (SDRAM_START+0x4000)
#define STACK_BASE_SYSTEM   (SDRAM_START+0x5000)

#define CODE_START (SDRAM_START+0x10000)  // this is where the board will jump and where qemu will copy our image

#define PROCESS_STACK_TOP 0xFFFFF000 // last page of stack 
#define PROCESS_STACK_BOTTOM 0xF0001000
#define IRQ_STACK_TOP (PROCESS_STACK_BOTTOM)
#define IRQ_STACK_BOTTOM (IRQ_STACK_TOP-1024)
#define SVC_STACK_TOP (IRQ_STACK_BOTTOM)
#define SVC_STACK_BOTTOM (SVC_STACK_TOP-1024)

#define KERNEL_RESERVED_END (SDRAM_START+0xA00000)
#define PROCESS_CODE_START (0x20000000)
#define PROCESS_CODE_END (PROCESS_CODE_START+0x10000000)

#define INSTALLED_RAM 512 // it is the max for integrator/cp
#define KERNEL_LEVEL1_PAGE_TABLE (SDRAM_START+0x100000)
#define KERNEL_LEVEL1_PAGE_TABLE_SIZE (4096*4)
#define KERNEL_LEVEL2_PAGE_TABLE (KERNEL_LEVEL1_PAGE_TABLE+KERNEL_LEVEL1_PAGE_TABLE_SIZE)
#define KERNEL_LEVEL2_PAGE_TABLE_SIZE (256*4)
#define KERNEL_PROCESS_LIST_SIZE (256)
#define KERNEL_PROCESS_LIST_SIZE_MASK (0xFF)
#define KERNEL_PROCESS_ENTRY_SIZE (256)
#define KERNEL_PROCESS_ENTRY_SIZE_SHIFT (8)
#define KERNEL_PROCESS_LIST_START (KERNEL_LEVEL2_PAGE_TABLE+(KERNEL_LEVEL2_PAGE_TABLE_SIZE*4096))
#define KERNEL_PROCESS_LIST_END (KERNEL_PROCESS_LIST_START+(KERNEL_PROCESS_LIST_SIZE*KERNEL_PROCESS_ENTRY_SIZE))
#define KERNEL_PHYSICAL_IRQ_STACK KERNEL_PROCESS_LIST_END
