#include "definitions.h"
#include "board.h"
#include "macros.h"

.global debugprint
.global debugprintRegister


//TODO: this function should own the serial port and lock it
// r4 = pointer to string
debugprint:
    mrs     r0,CPSR             // disable interrupts while doing this
    orr     r3,r0,#0b10000000
    msr     CPSR,r3

    ldr     r3,=SERIAL0_FLAG
1:  ldr     r5,[r3]
    ands    r5,#(1<<5)
    bne     1b  
    ldr     r3,=SERIAL0_BASE
    ldrb    r5,[r4],#1
    cmp     r5,#0
    mrseq   r0,CPSR             // put back interrupts like they  were before
    moveq   r15,r14
    str     r5,[r3]
    b       debugprint

// r1 = register to print content
debugprintRegister:
    push(r3-r7,r14)
    ldr     r7,=digits
    mov     r4,#8
    ldr     r3,=SERIAL0_FLAG
1:  ldr     r5,[r3]
    ands    r5,#(1<<5)
    bne     1b
    ldr     r3,=SERIAL0_BASE

    ubfx    r5,r1,#28,#4
    lsl     r1,#4
    ldr     r5,[r7,r5]
    str     r5,[r3]
    subs    r4,#1
    bne     1b
    
    pop(r3-r7,r15)
digits: .ASCII "0123456789ABCDEF"

